import sys, os, re
sys.path.append(os.path.join(os.path.dirname(__file__), "../trunk"))
try:
    pytests = sys.argv[1]
    jstests = sys.argv[2]
except:
    print "Syntax: %s test_backends testBackends.js" % sys.argv[0]
    sys.exit()

class Foo:
    def bar():
        pass

pylist = []
py = __import__("u1db.tests.%s" % pytests, fromlist=[pytests])
for classname in dir(py):
    cl = getattr(py, classname)
    for thing in dir(cl):
        if thing.startswith("test_"):
            actual_thing = getattr(cl, thing)
            if type(actual_thing) == type(Foo.bar):
                pylist.append("%s.%s" % (classname, actual_thing.__name__[5:]))

jslist = []
module_re = re.compile(r"""^\s*module\s*\(["'](?P<name>.*)['"]\s*,\s\{""")
test_re = re.compile(r"""^\s*test\s*\(["'](?P<name>.*)['"]\s*,\sfunction\(\)\s*\{""")
fp = open(jstests)
module = None
for line in fp:
    is_mod = module_re.match(line)
    if is_mod:
        module = is_mod.groupdict()["name"]
    is_test = test_re.match(line)
    if is_test:
        jslist.append("%s.%s" % (module, is_test.groupdict()["name"]))

pylist = set(pylist)
jslist = set(jslist)

ported = pylist.intersection(jslist)
unported = pylist.difference(jslist)
newtests = jslist.difference(pylist)
print "Ported tests"
print "------------"
print "\n".join(sorted(ported))
print
print "New tests"
print "---------"
print "\n".join(sorted(newtests))
print
print "Unported tests"
print "--------------"
print "\n".join(sorted(unported))
print
print "%s tests of %s ported from Python %s suite, %s (%s%%) not yet ported" % (
    len(ported), len(pylist), pytests, 
    len(unported), 100-int(100.0 * len(ported) / len(pylist)))


