module("errors", {})

test("sanity", function() {

    for (var err_name in U1DB.Errors) {
        var X = U1DB.Errors[err_name];
        equal(err_name, X.prototype.name);
        var x = new X();
        equal(err_name, x.name);
        ok(x instanceof Error);
        ok(x instanceof U1DB.Errors.U1DBError);
        if (err_name != 'HTTPError') {
            var y = new X("foo");
            equal("foo", y.message);
        }
        if (X.prototype.wire_description) {
            ok(U1DB.wire_to_error[X.prototype.wire_description] === X);
        }
    }

})

test("HTTPError", function() {
    var x = new U1DB.Errors.HTTPError(500, "bar");
    equal(500, x.status);
    equal("bar", x.message);
})
