var Utils = {
    assertRaisesFunction: function(fn, callback, message) {
        try {
            fn();
            ok(false, message);
        } catch (e) {
            ok(callback(e), message);
        }
    },

    assertGetDoc: function(db, doc_id, rev, obj, has_conflicts) {
        var d = db.get_doc(doc_id, {include_deleted: true});
        var exp_doc = new U1DBDocument(doc_id, rev, obj, has_conflicts);
        deepEqual(d, exp_doc, "assertGetDoc");
    },
    assertGetDocConflicts: function(db, doc_id, conflicts) {
        /* conflicts param is a list of [doc_rev, content] pairs */
        if (conflicts.length > 0) {
            var rconflicts = conflicts.slice(1);
            rconflicts.sort();
            conflicts = [conflicts[0]].concat(rconflicts);
        }
        var actual = db.get_doc_conflicts(doc_id);
        if (actual.length > 0) {
            var nactual = [];
            actual.forEach(function(doc) {
                nactual.push([doc.rev, doc.content]);
            });
            var ractual = nactual.slice(1);
            ractual.sort();
            actual = [nactual[0]].concat(ractual);;
        }
        deepEqual(conflicts, actual);
    },
    simple_doc: {key: "value"},
    nested_doc: {"key": "value", sub: {doc: "underneath"}},
    toString: function() { return "[Test object]"; }
};