/* bridge, javascript-side */
brdg_ex = function (globals, receive, respond, do_load, do_load_is_async) {
    var ns = {};

    function cmd_loop(until_cmd) {
        while(true) {
            var cmd = receive();
            if (cmd.op == until_cmd) {
                if (cmd.op == 'quit') {
                    respond({});
                    return;
                } else {
                    return cmd;
                }
            }
            var res = {}
            try {
                if (cmd.op == "eval") {
                    var value;
                    with (ns) {
                        value = eval(cmd.expr);
                    }
                    res = {value: typeof(value)=="undefined"?null:value};
                } else if(cmd.op == "load") {
                    if (until_cmd != "quit") {
                        throw new Error("load not allowed in callbacks");
                    }
                    if (do_load_is_async) {
                        do_load(cmd.fname, function() {
                            respond({});
                            cmd_loop("quit");
                        });
                        return;
                    } else {
                        do_load(cmd.fname);
                    }
                } else if (cmd.op == "global_names") {
                    res = [];
                    for(var name in globals) {
                        res.push(name);
                    }
                } else if(cmd.op == "retain") {
                    var value;
                    with (ns) {
                        value = eval(cmd.expr);
                    }
                    ns[cmd.name] = value;
                } else if(cmd.op == "forget") {
                    cmd.names.forEach(function(name) {
                        delete ns[name];
                    });
                } else if(cmd.op == "forget_all") {
                    ns = {}
                } else if(cmd.op == "callback_def") {
                    var cb_name = cmd.name;
                    function cb() {
                        var args = []
                        for (var j=0; j<arguments.length; j++) {
                            args.push(arguments[j]);
                        }
                        respond({cb: cb_name, args: args});
                        var cb_ret = cmd_loop("ret");
                        if ('exc' in cb_ret) {
                            var exc_name = cb_ret.exc;
                            var exc = Error;
                            if (exc_name in ns) {
                                exc = ns[exc_name];
                            }
                            throw new exc(cb_ret.message);
                        }
                        return cb_ret.value;
                    }
                    ns[cb_name] = cb
                }
            } catch(e) {
                res = {error: e.name||"unknownError", message: e.message,
                       fileName: e.fileName, lineNumber: e.lineNumber,
                       stack: e.stack};
            }
            respond(res);
        }
    }

    cmd_loop("quit")
};
